package org.dromara.personnel.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.personnel.domain.OpsWorkWage;
import org.dromara.personnel.mapper.OpsWorkWageMapper;
import org.springframework.stereotype.Service;
import org.dromara.personnel.domain.bo.OpsUserFilesBo;
import org.dromara.personnel.domain.vo.OpsUserFilesVo;
import org.dromara.personnel.domain.OpsUserFiles;
import org.dromara.personnel.mapper.OpsUserFilesMapper;
import org.dromara.personnel.service.IOpsUserFilesService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 运维人员文件Service业务层处理
 *
 * @author LionLi
 * @date 2025-09-17
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class OpsUserFilesServiceImpl extends ServiceImpl<OpsUserFilesMapper, OpsUserFiles> implements IOpsUserFilesService {

    private final OpsUserFilesMapper baseMapper;

    /**
     * 查询运维人员文件
     *
     * @param opsUserId 主键
     * @return 运维人员文件
     */
    @Override
    public OpsUserFilesVo queryById(Long opsUserId){
        return baseMapper.selectVoById(opsUserId);
    }

    /**
     * 分页查询运维人员文件列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 运维人员文件分页列表
     */
    @Override
    public TableDataInfo<OpsUserFilesVo> queryPageList(OpsUserFilesBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OpsUserFiles> lqw = buildQueryWrapper(bo);
        Page<OpsUserFilesVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的运维人员文件列表
     *
     * @param bo 查询条件
     * @return 运维人员文件列表
     */
    @Override
    public List<OpsUserFilesVo> queryList(OpsUserFilesBo bo) {
        LambdaQueryWrapper<OpsUserFiles> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OpsUserFiles> buildQueryWrapper(OpsUserFilesBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OpsUserFiles> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(OpsUserFiles::getOpsUserId);
        lqw.eq(bo.getFileId() != null, OpsUserFiles::getFileId, bo.getFileId());
        lqw.like(StringUtils.isNotBlank(bo.getFileName()), OpsUserFiles::getFileName, bo.getFileName());
        lqw.eq(StringUtils.isNotBlank(bo.getFileType()), OpsUserFiles::getFileType, bo.getFileType());
        return lqw;
    }

    /**
     * 新增运维人员文件
     *
     * @param bo 运维人员文件
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(OpsUserFilesBo bo) {
        OpsUserFiles add = MapstructUtils.convert(bo, OpsUserFiles.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setOpsUserId(add.getOpsUserId());
        }
        return flag;
    }

    /**
     * 修改运维人员文件
     *
     * @param bo 运维人员文件
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(OpsUserFilesBo bo) {
        OpsUserFiles update = MapstructUtils.convert(bo, OpsUserFiles.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OpsUserFiles entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除运维人员文件信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
